#include "ui_main.h"
#include "ui_startlevel.h"
#include "ui_collections.h"
#include "game.h"

#include <QDebug>
#include <QApplication>

#include <QWidget>
#include <QObject>

int main(int argc, char** argv)
{
    QApplication app(argc, argv);

    qDebug() << "Reading levels from" << LEVDIR;
    qDebug() << "Reading images from" << IMGDIR;

    QWidget mainWindow;

    Ui::Main ui;
    ui.setupUi(&mainWindow);

    Ui::StartLevel startUi;
    startUi.setupUi(ui.startWidget);
    QObject::connect(startUi.quitButton, SIGNAL(clicked()), &app, SLOT(quit()));

    Ui::LevelCollections levelUi;
    levelUi.setupUi(ui.collectionWidget);
    QObject::connect(levelUi.quitButton, SIGNAL(clicked()), &app, SLOT(quit()));

    GameField field(ui.gameTable);
    AvailablePieces pieces(ui.pieceTable);
    QStringList levelCollections;
    levelCollections << "intro" << "basic"; // TODO: read from fs
    GameController controller(&pieces, &field, ui.timeLabel, ui.doneButton);
    LevelSwitcher switcher(&controller,
                           ui.collectionWidget, levelUi.levelList, levelUi.startButton,
                           ui.startWidget, startUi.startTitle,
                           startUi.startLabel, startUi.startButton,
                           ui.levelLabel, ui.scoreLabel, levelCollections);

    mainWindow.show();

    return app.exec();
}
